//nano output pin supporting PWM, D3, D5, D6, D9, D10, D12
#include <EEPROM.h>
#include <MIDI.h>
MIDI_CREATE_DEFAULT_INSTANCE();

byte note = 0; // capteur 2 midi
byte Pad[36] = {36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 65, 66, 67, 68, 69, 70, 71}; // 36 NOTES

byte note2 = 0; // cv 2 midi
byte Pad2[52] = {36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80, 81, 82, 83, 84, 85, 86, 87}; // 52 NOTES

const byte gateOut = 4;
byte result = 0;
short resdel = 0;

boolean buttonState = 0;
boolean noteS = 0;
byte midiG =5;

const byte chnBt = 12; //button channel select
boolean butChn; // button channel
const byte ledChn = 11; // blinking channel led
byte chn; // midi channel
int address = 1; // memmory channel
 
void setup()
{
pinMode (gateOut, OUTPUT);
pinMode (midiG, INPUT_PULLUP);
pinMode(ledChn, OUTPUT);
pinMode(chnBt, INPUT_PULLUP);
chn = EEPROM.read(address);
delay (100);

if (chn == 0 || chn > 16)
{
chn = 1;
EEPROM.write(address, chn);
delay(1000);
MIDI.begin(chn);
start (chn);
}
else
{
delay(1000);
MIDI.begin(chn);
bar (chn);
}  
}
void start(byte chn)
{
    for (byte i=0; i<chn; i++) 
    {
    digitalWrite(ledChn, HIGH);
    delay(50);
    digitalWrite(ledChn, LOW);
    delay(400);
    loop();
    }
}
void bar(byte chn)
{
    for (byte i=0; i<chn; i++) 
    {
    digitalWrite(ledChn, HIGH);
    delay(50);
    digitalWrite(ledChn, LOW);
    delay(400);
    }
}
void loop()
{
  
  resdel = map (analogRead(A0), 0, 1023, 384, 2); // delay
  buttonState = digitalRead(midiG); // midi gate in
  butChn = digitalRead(chnBt); // button channnel select
	
	if (butChn == HIGH) // off (on) || HIGH on (off) 
      {
      chn+=1;
      if (chn <= 16)
      {
      EEPROM.write(address, chn);
      delay(500);
      MIDI.begin(chn);
      bar (chn);
      }
      if (chn >= 17)
      {
      chn = 1;
      EEPROM.write(address, chn);
      delay(500);
      MIDI.begin(chn);
      bar(chn);
      }
      }
   
if (analogRead(A1) >= 203 && analogRead(A1) <= 517 && analogRead(A7) <5) 
   { 
    result = map(analogRead(A1), 203 , 517, 0, 255);
    note = map (analogRead(A1), 203, 517, 0, 35);
    analogWrite(3, result);
    digitalWrite(gateOut, HIGH); //gate out
    digitalWrite(2, HIGH);
    MIDI.sendNoteOn(Pad[note], 127, chn);
	delay(resdel);
		
   }
   else if (analogRead(A1) < 203 && analogRead(A7) <5)
   {
    result = 0;
    analogWrite(3, result); //pwm out
    digitalWrite(gateOut, LOW); // gate out
    digitalWrite(2, LOW); // gate led
    MIDI.sendNoteOff(Pad[note], 0, chn);
	delay(resdel);
    }
    else if (analogRead(A1) > 517 && analogRead(A7) <5)
    {
    result = 255;
    analogWrite(3, result);
    digitalWrite(gateOut, LOW);
    digitalWrite(2, LOW);
    MIDI.sendNoteOff(Pad[note], 0, chn);
	delay(resdel);
    }
    if (analogRead(A7) >5)
      {
		  if (buttonState == LOW) {
    if (noteS == 0) {
        result = map(analogRead(A7), 6 , 1023, 0, 255);
        note2 = map (analogRead(A7), 6, 1023, 0, 51);
        analogWrite(3, result); //pwm out
        digitalWrite(gateOut, HIGH); // gate out
        digitalWrite(2, HIGH); // gate led
        MIDI.sendNoteOn(Pad2[note2], 127, chn);
      noteS = 1;
    }
  }
  else 
   {
    if (noteS == 1) 
	{
		result = map(analogRead(A7), 6 , 1023, 0, 255);
		analogWrite(3, result); //pwm out
		digitalWrite(gateOut, LOW); // gate out
        digitalWrite(2, LOW); // gate led
        MIDI.sendNoteOff(Pad2[note2], 0, chn);
    }
    noteS = 0;
    }    
}
}


